(function (DPHelper, $) {
    DPHelper.ActivityName = {
        CST: "ford_customersatisfactiontools",
        FAR: "ford_financialassistancerequestentity",
        PortalMessage: "ford_portalmessage",
        RentalDetail: "ford_rentaldetailentity",
        VLA: "ford_vehicleloyaltyallowance",
        IWL: "ford_warrantyloanerrequestentity",
        VOR: "ford_vehicleoffroadentity",
        CatalogInquiry: "ford_cataloginquiry",
        DealerClaims: "ford_dealerclaim",
        FCSInquiry: "ford_fcsinquiry",
        PartAvailability: "ford_partavailabilityinquiry",
        PartOrderStatus: "ford_partorderstatusinquiry",
        PartQualityControl: "ford_partqualitycontrolinquiry",
        PricingInquiry: "ford_pricinginquiries",
        TrafficInquiry: "ford_trafficinquiry",
        FSALoaner: "ford_fsaloaner",
    };

    DPHelper.CaseClassificationIds = {
        FARRepair: "9f4ec59a-b137-ee11-bdf4-0022482b6eda",
        FSALoaner: "70365ED0-C56B-EF11-BFE2-7C1E5215068A",
    };

    DPHelper.CaseInitiatinguser = {
        Agent: '660870000',
        Dealer: '660870001',
        Distributor: '660870002',
        ExternalSystem: '660870003',
    };

    DPHelper.FuelType = {
        Gas: "660870000",
        Diesel: "660870001",
        Bev: "660870002"
    };

    // Generic function to set Lookup Fields
    DPHelper.setLookupField = (field, lookupValue, id, entityName) => {
        $("#" + field + "_name").attr("value", lookupValue);
        $("#" + field + "_name").val(lookupValue);
        $("#" + field).attr("value", id);
        $("#" + field).val(id);
        $("#" + field + "_entityname").attr("value", entityName);
        $("#" + field + "_entityname").val(entityName);
    };

    //Generic function to disable Lookup Fields added
    DPHelper.disableLookup = (pLookupNameID, pLookupEntityNameID) => {
        var LookupEntityNameID = "#" + pLookupEntityNameID;
        var LookupNameID = "#" + pLookupNameID;
        //$(LookupEntityNameID).parent().find('.input-group-btn').hide();
        $(LookupNameID).parent().find(".fa-search").parent().attr("style", "background-color: #ebebe4 !important");
        $(LookupNameID).parent().find(".fa-search").parent().css("pointer-events", "none");
        $(LookupNameID).parent().find(".fa-times").parent().attr("style", "background-color: #ebebe4 !important");
        $(LookupNameID).parent().find(".fa-times").parent().css("pointer-events", "none");
        $(LookupNameID).prop("disabled", true);
        $(LookupNameID).css("background-color", "#ebebe4");
    };

    //Function to enable the lookup
    DPHelper.enableLookup = (pLookupNameID, pLookupEntityNameID) => {
        var LookupEntityNameID = "#" + pLookupEntityNameID;
        var LookupNameID = "#" + pLookupNameID;
        //$(LookupEntityNameID).parent().find('.input-group-btn').show();
        $(LookupNameID).parent().find(".fa-search").parent().css("pointer-events", "auto");
        $(LookupNameID).parent().find(".fa-search").parent().css("background-color", "");
        $(LookupNameID).parent().find(".fa-times").parent().css("pointer-events", "auto");
        $(LookupNameID).parent().find(".fa-times").parent().css("background-color", "");
        $(LookupNameID).prop("disabled", false);
    };

    DPHelper.enableLookupList = (LookupFieldsList) => {
        var LookupFiledsArray = LookupFieldsList.split(",");
        for (intCount = 0; intCount < LookupFiledsArray.length; intCount += 1) {
            DPHelper.enableLookup(LookupFiledsArray, null);                    
        }
    };

    DPHelper.disableLookupList = (LookupFieldsList) => {
        var LookupFiledsArray = LookupFieldsList.split(",");
        for (intCount = 0; intCount < LookupFiledsArray.length; intCount += 1) {
            var LookupEntityNameID = "#" + LookupFiledsArray[intCount] + "_entityname";
            var LookupNameID = "#" + LookupFiledsArray[intCount] + "_name";
            //$(LookupEntityNameID).parent().find('.input-group-btn').hide();
            $(LookupNameID).parent().find(".fa-search").parent().attr("style", "background-color: #ebebe4 !important");
            $(LookupNameID).parent().find(".fa-search").parent().css("pointer-events", "none");
            $(LookupNameID).parent().find(".fa-times").parent().attr("style", "background-color: #ebebe4 !important");
            $(LookupNameID).parent().find(".fa-times").parent().css("pointer-events", "none");
            $(LookupNameID).prop("disabled", true);
            //$(LookupNameID).css('width', '610px');
            $(LookupNameID).css("background-color", "#ebebe4");
            "$('#" + LookupFiledsArray[intCount] + "_name').prop('disabled', true)";
            "$('#" + LookupFiledsArray[intCount] + "_name').prop('disabled', 'disabled')";
        }
    };

    DPHelper.makeNotRequired = (fieldName) => {
        try {
            if ($("#" + fieldName) != undefined) {
                $("#" + fieldName + "_label")
                    .parent()
                    .removeClass("required");
                $("#" + fieldName)
                    .closest(".control")
                    .prev()
                    .removeClass("required");
                $("#" + fieldName).prop("required", false);
                if ($("#RequiredFieldValidator" + fieldName) != undefined) {
                    $("#RequiredFieldValidator" + fieldName).attr("style", "display:none !important");
                    $("#RequiredFieldValidator" + fieldName).html("");
                }

                for (i = 0; i < Page_Validators.length; i++) {
                    if (Page_Validators[i].id == fieldName + "Validator" || Page_Validators[i].id == "RequiredFieldValidator" + fieldName) {
                        Page_Validators.splice(i, 1);
                    }
                }
            }
        } catch (error) {
            errorHandler(error);
        }
    };

    //Function to make a field required
    DPHelper.makeRequired = (fieldName) => {
        try {
            if ($("#" + fieldName) != undefined && !DPHelper.IsValidationControlExist(fieldName)) {
                $("#" + fieldName).prop("required", true);
                $("#" + fieldName)
                    .closest(".control")
                    .prev()
                    .addClass("required");

                // Create new validator
                var Requiredvalidator = document.createElement("span");
                let fieldNameLabel = $(`#${fieldName}_label`).html();
                Requiredvalidator.style.display = "none";
                Requiredvalidator.id = fieldName + "Validator";
                Requiredvalidator.controltovalidate = fieldName;
                Requiredvalidator.errormessage = `<a href='#${fieldName}_label'>${formatMessage(requireFieldErrMsg, fieldNameLabel)}</a>`;
                Requiredvalidator.initialvalue = "";
                Requiredvalidator.evaluationfunction = function () {
                    return DPHelper.notNullOrUndefinedOrEmpty($("#" + fieldName).val());
                };
                // Add the new validator to the page validators array:
                Page_Validators.push(Requiredvalidator);
            }
        } catch (error) {
            errorHandler(error);
        }
    };

    DPHelper.IsValidationControlExist = (fieldName) => {
        for (i = 0; i < Page_Validators.length; i++) {
            if (Page_Validators[i].id == fieldName + "Validator" || Page_Validators[i].id == "RequiredFieldValidator" + fieldName) {
                return true;
            }
        }
        return false;
    };

    //Function to reload the page
    DPHelper.TimedRefresh = (t) => {
        setTimeout("location.reload(true);", t);
    };

    //Function to read query string values
    DPHelper.getParameterByName = (name) => {
        var url = window.location.href;
        name = name.replace(/[\[\]]/g, "\\$&");
        var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
            results = regex.exec(url);
        if (!results) return null;
        if (!results[2]) return "";
        return decodeURIComponent(results[2].replace(/\+/g, " "));
    };

    //Rounding the number at decimal level. scale is number of decimals
    DPHelper.roundNumberAtDecimal = (num, scale) => {
        if (!("" + num).includes("e")) {
            return +(Math.round(num + "e+" + scale) + "e-" + scale);
        } else {
            var arr = ("" + num).split("e");
            var sig = "";
            if (+arr[1] + scale > 0) {
                sig = "+";
            }
            var i = +arr[0] + "e" + sig + (+arr[1] + scale);
            var j = Math.round(i);
            var k = +(j + "e-" + scale);
            return k;
        }
    };


    //function to set date in the date picker
    DPHelper.setDateTimeFieldValue = (fieldId, dateValue) => {
        //Get the submit field
        var $submitField = $("#" + fieldId);
        //Get the display field
        var $displayField = $submitField.nextAll(".datetimepicker").children("input");
        //Get the display date format
        var dateFormat = $displayField.attr("data-date-format");
        //Set the submit field. Remember this needs to be in UTC and the format must be exact.
        $submitField.val(moment.utc(dateValue).format("YYYY-MM-DDTHH:mm:ss.SSSSSSS"));
        //Set the display field using the page's date format
        $displayField.val(moment(dateValue).format(dateFormat));
    };

    DPHelper.sleep = (milliseconds) => {
        return new Promise(function (resolve) {
            setTimeout(resolve, milliseconds);
        });
    };

    //Function to validate input object contains data. Returns true if input value is not null or undefined.
    DPHelper.notNullOrUndefined = (value) => {
        return value != null && value != undefined && typeof value != "undefined";
    };

    //Function to validate input string contains data. Returns true if input string is not null or undefined or empty string.
    DPHelper.notNullOrUndefinedOrEmpty = (value) => {
        return value != null && value != undefined && typeof value != "undefined" && typeof value == "string" && value.trim() != "";
    };

    DPHelper.decodeHtmlString = (str) => {
        return str.replace(/&#(\d+);/g, function (match, dec) {
            return String.fromCharCode(dec);
        });
    };

    //Function to get window location. if input parameter is true then it returns window location url with language code else only window location url
    DPHelper.getWindowLocation = (langCodeRequired = true) => {
        return (
            (window.location.origin
                ? window.location.origin
                : window.location.protocol + "//" + window.location.hostname + (window.location.port ? ":" + window.location.port : "")) +
            (langCodeRequired == true ? siteLangCode : "")
        );
    };

    //validate a length for a value, use a min and max condition
    DPHelper.Validatelength = (pvalue, min, max) => {
        var flag = false;

        if (pvalue.length < min || pvalue.length > max) {
            flag = true;
        }

        return flag;
    };
})((window.DPHelper = window.DPHelper || {}), jQuery);

function formatMessage() {
  var args = Array.prototype.slice.call(arguments, 1);
  return arguments[0].replace(/\{(\d+)\}/g, function (match, index) {
    return args[index];
  });
}

 //Function to Disable Date Control fields
 DPHelper.disableDatecontrol = (fieldname) => {
  var DateControlName = "#" + fieldname;
  $(DateControlName).next().data("DateTimePicker").disable();
  $(DateControlName).css("background-color", "#ebebe4");
};

 //Function Calendar field set Max Date to Current Date allowed
 DPHelper.setMaxDateonDatecontrol = (dateControlField) => {
  var DateControlName = "#" + dateControlField;
  $(DateControlName).next().data("DateTimePicker").maxDate(moment());
};

//Function Calendar field set Min Date to  Date allowed
DPHelper.setMinDateonDatecontrol = (dateControlField, mindatevalue) => {
  //Parse the min date value to required format
  var mindateparse = Date.parse(new Date($("#" + mindatevalue).val())).toString("MM/dd/yyyy");
  var DateControlName = "#" + dateControlField;
  //Logic to restrict the date control field to have Min value
  $(DateControlName).next().data("DateTimePicker").minDate(mindateparse);
};
//Function to Disable fields
DPHelper.disablefields = (fiedllistval) => {
    var FiledsArray = fiedllistval.split(",");
    for (intCount = 0; intCount < FiledsArray.length; intCount += 1) {
        var fieldname = '#' + FiledsArray[intCount];
        $(fieldname).prop("disabled", true);
    }
};
//Function to Enable fields
DPHelper.enablefields = (fiedllistval) => {
    var FiledsArray = fiedllistval.split(",");
    for (intCount = 0; intCount < FiledsArray.length; intCount += 1) {
        var fieldname = '#' + FiledsArray[intCount];
        $(fieldname).prop("disabled", false);
    }
};